# Class VulkanClearAttachment.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanClearAttachment.Builder

Enclosing class:
  `VulkanClearAttachment`

public static final class VulkanClearAttachment.Builder extends Object
Builds instances of type `VulkanClearAttachment`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanClearAttachment.Builder`
  `addAllAspectMask(Iterable<VulkanImageAspectFlag> elements)`
  Adds elements to `aspectMask` set.
  `final VulkanClearAttachment.Builder`
  `addAspectMask(VulkanImageAspectFlag element)`
  Adds one element to `aspectMask` set.
  `final VulkanClearAttachment.Builder`
  `addAspectMask(VulkanImageAspectFlag... elements)`
  Adds elements to `aspectMask` set.
  `VulkanClearAttachment`
  `build()`
  Builds a new `VulkanClearAttachment`.
  `final VulkanClearAttachment.Builder`
  `from(VulkanClearAttachmentType instance)`
  Fill a builder with attribute values from the provided `VulkanClearAttachmentType` instance.
  `final VulkanClearAttachment.Builder`
  `setAspectMask(Iterable<VulkanImageAspectFlag> elements)`
  Sets or replaces all elements for `aspectMask` set.
  `final VulkanClearAttachment.Builder`
  `setClearValue(VulkanClearValueType clearValue)`
  Initializes the value for the `clearValue` attribute.
  `final VulkanClearAttachment.Builder`
  `setColorAttachment(int colorAttachment)`
  Initializes the value for the `colorAttachment` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanClearAttachment.Builder from(VulkanClearAttachmentType instance)
    Fill a builder with attribute values from the provided `VulkanClearAttachmentType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addAspectMask

    public final VulkanClearAttachment.Builder addAspectMask(VulkanImageAspectFlag element)
    Adds one element to `aspectMask` set.
    Parameters:
      `element` - A aspectMask element
    Returns:
      `this` builder for use in a chained invocation

  - ### addAspectMask

    public final VulkanClearAttachment.Builder addAspectMask(VulkanImageAspectFlag... elements)
    Adds elements to `aspectMask` set.
    Parameters:
      `elements` - An array of aspectMask elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setAspectMask

    public final VulkanClearAttachment.Builder setAspectMask(Iterable<VulkanImageAspectFlag> elements)
    Sets or replaces all elements for `aspectMask` set.
    Parameters:
      `elements` - An iterable of aspectMask elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllAspectMask

    public final VulkanClearAttachment.Builder addAllAspectMask(Iterable<VulkanImageAspectFlag> elements)
    Adds elements to `aspectMask` set.
    Parameters:
      `elements` - An iterable of aspectMask elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setColorAttachment

    public final VulkanClearAttachment.Builder setColorAttachment(int colorAttachment)
    Initializes the value for the `colorAttachment` attribute.
    Parameters:
      `colorAttachment` - The value for colorAttachment
    Returns:
      `this` builder for use in a chained invocation

  - ### setClearValue

    public final VulkanClearAttachment.Builder setClearValue(VulkanClearValueType clearValue)
    Initializes the value for the `clearValue` attribute.
    Parameters:
      `clearValue` - The value for clearValue
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanClearAttachment build()
    Builds a new `VulkanClearAttachment`.
    Returns:
      An immutable instance of VulkanClearAttachment
    Throws:
      `IllegalStateException` - if any required attributes are missing